<?php 
$controller = 'User';
$action = '';
if(isset($_POST['action'])){
    $action = $_POST['action'];
    if (isset($_POST['id'])) {$id = $_POST['id'];}
}elseif(isset($_GET['action'])){
    $action = $_GET['action'];
    if (isset($_GET['id'])) {$id = $_GET['id'];}
}
include $_SERVER["DOCUMENT_ROOT"].'/app/include/bootstrap.php';

$form = new UsuarioForm();
$_usuario = new UsuarioEntity();

switch($action){
    case 'insert':
        $form->populate($_POST);
        if($form->isValid()){
            $_usuario->setOptions($_POST);
            $result = $_usuario->save($_usuario->getOptions());
            if($result){
                $flashmessenger->addMessage(array('success'=>'Usuario registrado exitosamente.'));
                header('Location: User.php');
            }else{
                $flashmessenger->addMessage(array('danger'=>'Error. Intenta nuevamente o contacta a tu proveedor de sistemas.'));
            }
        }else{
            $_listaUsuarios = $_usuario->getListaUsuarios();
            $vista = 'Usuario.php';
            include $root.'/View/Template.php';
        }
        break;
   
    case 'edit':
        if($_GET){
            $_usuarioData = $_usuario->getById($id);
            $_usuarioData['contrasena'] = null;
            $_usuarioData['nip'] = null;
            $_usuarioData['sucursal'] = $_usuario->sucursalesStringToArray($_usuarioData['sucursal']);
        }
        
        if($_POST){$_usuarioData = $_POST;}
        
        $login = new Login();
        if($login->getId() != $id && $login->getRole() != '1'){
            $flashmessenger->addMessage(array('info'=>'No tienes permiso para acceder a este modulo.'));
            header('Location: Home.php');
        }
        
        $form->setActionController('edit');
        $form->setId($id);
        $form->setEditForm();
        $form->populate($_usuarioData);
        
        $_listaUsuarios = $_usuario->getListaUsuarios();
        if(isset($_POST['id'])){
            if($form->isValid()){
                $_usuario->setOptions($_usuarioData);
                $result = $_usuario->update($id,$_usuario->getOptions()); //no tengo id porque viene de post
                if($result){
                    $flashmessenger->addMessage(array('success'=>'Usuario actualizado exitosamente.'));
                    header("Location: User.php?action=edit&id=$id");
                }else{
                    $flashmessenger->addMessage(array('danger'=>'Error. Intenta nuevamente o contacta a tu proveedor de sistemas.'));
                }       
            }else{
                $vista = 'Usuario.php';
                include $root . '/View/Template.php';
            }
        }else{
            $vista = 'Usuario.php';
            include $root . '/View/Template.php';
        }        
        break;
    
    case 'delete': 
        if(!$_usuario->isUsedInRecord($id)){
            if($_usuario->delete($id)){
                $flashmessenger->addMessage(array('success'=>'Usuario eliminado satisfactoriamente.'));
            }
        }else{
            $message = 'Este Usuario no puede ser eliminado, esta siendo utilizado en almenos un registro.';
            $flashmessenger->addMessage(array('info'=>$message));
        }
       header("Location: User.php");
        break;
    
    default:
        $_listaUsuarios = $_usuario->getListaUsuarios();
        $vista = 'Usuario.php';
        include $root.'/View/Template.php';
}